#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

vector<long long> tree(4000000, 0);

long long gcd(long long a, long long b)
{
    if (a == 0 || b == 0)
    {
        return max(a, b);
    }
    if (a > b)
    {
        return gcd(b, a % b);
    }
    else
    {
        return gcd(a, b % a);
    }
}

long long getans(int v, int vl, int vr, int l, int r)
{
    if (vr < l || vl > r)
        return 0;
    if (vl >= l && vr <= r)
        return tree[v];
    int m = (vl + vr) / 2;
    return gcd(getans(2 * v, vl, m, l, r), getans(2 * v + 1, m + 1, vr, l, r));
}



int main()
{

    int n, k;
    cin >> n >> k;
    vector<long long> a(n, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    int N = 1;
    while (N < n) N *= 2;

    for (int i = 0; i < n; i++)
    {
        tree[i + N] = a[i];
    }
    for (int i = N - 1; i > 0; i--)
    {
        tree[i] = gcd(tree[2 * i], tree[2 * i + 1]);
    }

    long long ans = 1;
    for (int i = k; i < n; i++)
    {
        ans = max(ans, getans(1, 1, N, i - k + 2, i + 1));
    }

    cout << ans;
}
/*
10 4
2 3 4 8 12 6 12 18 4 3

6 3
2 2 4 12 24 6
*/
