#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ull;

struct coord
{
	coord(ull nx, ull ny)
	{
		x = nx;
		y = ny;
	}

	bool operator>(coord C)
	{
		if (C.y == y)
			return x > C.x;
		return y > C.y;
	}

	bool operator<(coord C)
	{
		if (C.y == y)
		    return x < C.x;
		return y < C.y;
	}

	bool operator==(coord C)
	{
		return (x == C.x) && (y == C.y);
	}

	coord & operator+=(coord C)
	{
		x += C.x;
		y += C.y;
		return *this;
	}

	ull x, y;
};

int main(void)
{
	ull n, d, k;
	std::vector<coord> Path;

	std::cin >> n >> d >> k;
	coord Pos(0, 0);
	int ND = 0;
	coord Dirs[] = { {1, 0}, {0, -1}, {-1, 0}, {0, 1} };
	coord MinPos(0, 0);
	coord MaxPos(0, 0);

	Path.push_back(Pos);

	try
	{
		for (int i = 0;;)
		{
			for (ull k = 0; k < d; k++)
			{
				if (i == n)
					throw 0;
				Pos += Dirs[ND];
				MaxPos.x = (Pos.x > MaxPos.x) ? Pos.x : MaxPos.x;
				MinPos.x = (Pos.x < MinPos.x) ? Pos.x : MinPos.x;
				Path.push_back(Pos);
				i++;
			}
			ND++;
			if (ND > 3)
				ND = 0;
			for (ull k = 0; k < d; k++)
			{
				if (i == n)
					throw 0;
				Pos += Dirs[ND];
				MaxPos.y = (Pos.y > MaxPos.y) ? Pos.y : MaxPos.y;
				MinPos.y = (Pos.y < MinPos.y) ? Pos.y : MinPos.y;
				Path.push_back(Pos);
				i++;
			}
			ND++;
			if (ND > 3)
				ND = 0;
			d *= k;
		}
	}
	catch (int Zero)
	{
	}

	std::sort(Path.begin(), Path.end());

	std::cout << MaxPos.y - MinPos.y + 1 << " " << MaxPos.x - MinPos.x + 1 << "\n";

	int i = 0;
	for (ull y = MinPos.y; y <= MaxPos.y; y++)
	{
		for (ull x = MinPos.x; x <= MaxPos.x; x++)
		{
			if (i < Path.size() && coord(x, y) == Path[i])
				std::cout << "*", i++;
			else
				std::cout << ".";
		}
		std::cout << ((y == MaxPos.y) ? "" : "\n");
	}

	return 0;
}

/*  B
    ull n;
	ull k = 0;
	ull i = 1;
	ull S = 1;

	std::cin >> n;

	while (n > S)
	{
		i++;
		S += i * i;
	}

	std::cout << i - 1;
*/