#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <cstdio>

#define min(a, b) a < b ? a : b
#define max(a, b) a > b ? a : b

class vec2
{
public:
  int x, y;

  vec2( void )
  {
  }

  vec2(int x, int y) : x(x), y(y)
  {
  }
};

int Find( const std::vector<vec2> &Path, vec2 i )
{
  for (auto c = Path.begin(); c != Path.end(); ++c)
    if (c->x == i.x && c->y == i.y)
      return 1;
  return 0;
}
int main( void )
{
  int n, d, k, x = 0, y = 0, w = 0, h = 0;
  std::vector<vec2> Path;
  vec2 A(x, y);

  std::cin >> n >> d >> k;

  Path.push_back(vec2(0, 0));
  while (n > 0)
  {
    int a = d;

    while (n > 0 && a > 0)
    {
      A.x++, a--;
      n--;
      Path.push_back(A);
    }
    if (n <= 0)
      break;

    a = d;
    while (n > 0 && a > 0)
    {
      A.y++, a--;
      n--;
      Path.push_back(A);
    }
    if (n <= 0)
      break;

    d *= k;
    a = d;
    while (n > 0 && a > 0)
    {
      A.x--, a--; 
      n--;
      Path.push_back(A);
    }
    if (n <= 0)
      break;

    a = d;
    while (n > 0 && a > 0)
    {
      A.y--, a--; 
      n--;
      Path.push_back(A);
    }
    if (n <= 0)
      break;

    d *= k;
  }

  int Max[2] = {-64000}, Min[2] = {64000};
  for (auto c : Path)
  {
    Min[0] = min(c.x, Min[0]);
    Max[0] = max(c.x, Max[0]);

    Min[1] = min(c.y, Min[y]);
    Max[1] = max(c.y, Max[y]);
  }

  w = Max[0] - Min[0] + 1;
  h = Max[1] - Min[1] + 1;

  std::cout << w << " " << h << "\n";

  for (int i = 0; i < h; i++)
  {
    for (int j = 0; j < w; j++)
    {
      if (Find(Path, vec2(Min[0] + j, Max[1] - i)))
        std::cout << "*";
      else
        std::cout << ".";
    }
    std::cout << "\n";
  }

  return 0;
}