#include <cstdio>
#include <iostream>

int main( void )
{
  int n, d, k;
  std::cin >> n >> d >> k;
  int coords[1000][2] = {{0, 0}};
  int steps = 1, i = 0;
  int dirs[4][2] =
  {
    {1, 0},
    {0, 1},
    {-1, 0},
    {0, -1}
  }, cur_dir = 0;
  int minx = 0, maxx = 0, miny = 0, maxy = 0;
  while (steps < n + 1)
  {
    bool to_break = false;
    int num = d;
    if (steps + d >= n + 1)
      to_break = true, num = n + 1 - steps;

    steps += num;

    coords[i + 1][0] = coords[i][0] + dirs[cur_dir][0] * num;
    coords[i + 1][1] = coords[i][1] + dirs[cur_dir][1] * num;
    if (coords[i + 1][0] > maxx)
      maxx = coords[i + 1][0];
    if (coords[i + 1][0] < minx)
      minx = coords[i + 1][0];
    if (coords[i + 1][1] > maxy)
      maxy = coords[i + 1][1];
    if (coords[i + 1][1] < miny)
      miny = coords[i + 1][1];

    if (to_break)
      break;

    if (i++ % 2 == 1)
      d *= k;
    cur_dir = (cur_dir + 1) % 4;
  }

  if (maxx > -minx)
    minx = -maxx;
  else
    maxx = -minx;
  if (maxy > -miny)
    miny = -maxy;
  else
    maxy = -miny;
  int w = maxx - minx + 1, h = maxy - miny + 1;

  std::cout << w << " " << h << std::endl;

  char *pole = new char[w * h];
  memset(pole, '.', w * h);

  pole[(0 - miny) * w + 0 - minx] = '*';

  for (int j = 1; j <= i + 1; j++)
    if (coords[j][0] != coords[j - 1][0])
    {
      // go along x
      int dir = (coords[j][0] > coords[j - 1][0] ? 1 : -1);
      for (int k = coords[j - 1][0] + dir; k != coords[j][0]; k += dir)
        pole[(coords[j][1] - miny) * w + k - minx] = '*';
      pole[(coords[j][1] - miny) * w + coords[j][0] - minx] = '*';
    }
    else
    {
      // go along y
      int dir = (coords[j][1] > coords[j - 1][1] ? 1 : -1);
      for (int k = coords[j - 1][1] + dir; k != coords[j][1]; k += dir)
        pole[(k - miny) * w + coords[j][0] - minx] = '*';
      pole[(coords[j][1] - miny) * w + coords[j][0] - minx] = '*';
    }

  for (int i = h - 1; i >= 0; i--)
  {
    for (int j = 0; j < w; j++)
      std::cout << pole[i * w + j];
    std::cout << std::endl;
  }
  delete[] pole;

  return 0;
}